Package org.apache.lucene.spatial.spatial4j

## Class Geo3dRectangleShape

- java.lang.Object
- - org.apache.lucene.spatial.spatial4j.Geo3dShape<GeoBBox>
  - - org.apache.lucene.spatial.spatial4j.Geo3dRectangleShape

- All Implemented Interfaces:
    `org.locationtech.spatial4j.shape.Rectangle`, `org.locationtech.spatial4j.shape.Shape`

      public class Geo3dRectangleShape
      extends Geo3dShape<GeoBBox>
      implements org.locationtech.spatial4j.shape.Rectangle

  Specialization of a `Geo3dShape` which represents a `Rectangle`.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.spatial.spatial4j.Geo3dShape

      `boundingBox, center, shape, spatialcontext`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Geo3dRectangleShape​(GeoBBox shape, org.locationtech.spatial4j.context.SpatialContext spatialcontext)` |
    `Geo3dRectangleShape​(GeoBBox shape, org.locationtech.spatial4j.context.SpatialContext spatialcontext, double minX, double maxX, double minY, double maxY)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.locationtech.spatial4j.shape.Rectangle` | `getBoundingBox()` |
    `org.locationtech.spatial4j.shape.Shape` | `getBuffered​(double distance, org.locationtech.spatial4j.context.SpatialContext spatialContext)` |
    `org.locationtech.spatial4j.shape.Point` | `getCenter()` |
    `boolean` | `getCrossesDateLine()` |
    `double` | `getHeight()` |
    `double` | `getMaxX()` |
    `double` | `getMaxY()` |
    `double` | `getMinX()` |
    `double` | `getMinY()` |
    `double` | `getWidth()` |
    `org.locationtech.spatial4j.shape.SpatialRelation` | `relateXRange​(double minX, double maxX)` |
    `org.locationtech.spatial4j.shape.SpatialRelation` | `relateYRange​(double minY, double maxY)` |
    `void` | `reset​(double minX, double maxX, double minY, double maxY)` |

    - ### Methods inherited from class org.apache.lucene.spatial.spatial4j.Geo3dShape

      `equals, getArea, getContext, hasArea, hashCode, isEmpty, relate, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.locationtech.spatial4j.shape.Shape

      `equals, getArea, getContext, hasArea, isEmpty, relate`

- - ### Constructor Detail

    - #### Geo3dRectangleShape

          public Geo3dRectangleShape​(GeoBBox shape,
                                     org.locationtech.spatial4j.context.SpatialContext spatialcontext,
                                     double minX,
                                     double maxX,
                                     double minY,
                                     double maxY)

    - #### Geo3dRectangleShape

          public Geo3dRectangleShape​(GeoBBox shape,
                                     org.locationtech.spatial4j.context.SpatialContext spatialcontext)

  - ### Method Detail

    - #### getCenter

          public org.locationtech.spatial4j.shape.Point getCenter()

      Specified by:
        `getCenter` in interface `org.locationtech.spatial4j.shape.Shape`
      Overrides:
        `getCenter` in class `Geo3dShape<GeoBBox>`

    - #### reset

          public void reset​(double minX,
                            double maxX,
                            double minY,
                            double maxY)

      Specified by:
        `reset` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getBoundingBox

          public org.locationtech.spatial4j.shape.Rectangle getBoundingBox()

      Specified by:
        `getBoundingBox` in interface `org.locationtech.spatial4j.shape.Shape`
      Overrides:
        `getBoundingBox` in class `Geo3dShape<GeoBBox>`

    - #### getWidth

          public double getWidth()

      Specified by:
        `getWidth` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getHeight

          public double getHeight()

      Specified by:
        `getHeight` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getMinX

          public double getMinX()

      Specified by:
        `getMinX` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getMinY

          public double getMinY()

      Specified by:
        `getMinY` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getMaxX

          public double getMaxX()

      Specified by:
        `getMaxX` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getMaxY

          public double getMaxY()

      Specified by:
        `getMaxY` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getCrossesDateLine

          public boolean getCrossesDateLine()

      Specified by:
        `getCrossesDateLine` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### relateYRange

          public org.locationtech.spatial4j.shape.SpatialRelation relateYRange​(double minY,
                                                                               double maxY)

      Specified by:
        `relateYRange` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### relateXRange

          public org.locationtech.spatial4j.shape.SpatialRelation relateXRange​(double minX,
                                                                               double maxX)

      Specified by:
        `relateXRange` in interface `org.locationtech.spatial4j.shape.Rectangle`

    - #### getBuffered

          public org.locationtech.spatial4j.shape.Shape getBuffered​(double distance,
                                                                    org.locationtech.spatial4j.context.SpatialContext spatialContext)

      Specified by:
        `getBuffered` in interface `org.locationtech.spatial4j.shape.Shape`
      Overrides:
        `getBuffered` in class `Geo3dShape<GeoBBox>`